"{ Package: 'stx:goodies/libcairo' }"

"{ NameSpace: Cairo }"

Smalltalk::GLXWorkstation subclass:#GLXWorkstation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Cairo-Workstation'
!


!GLXWorkstation methodsFor:'bitmap/window creation'!

destroyGC:cr 
    ^ super destroyGC:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

dpsContextFor:aDrawableId and:cr 
    ^ super dpsContextFor:aDrawableId and:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

gcFor:aDrawableId

    | view |
    view := self viewFromId: aDrawableId.
    self infoPrintCR: 'creating GC for ', aDrawableId printString.
    ^Cairo::Surface 
                forXlib: displayId
                drawable: aDrawableId address 
                visual: self visualStructure 
                width: view width 
                height: view height.

    "Created: / 10-09-2008 / 21:14:33 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

gcForBitmap:aDrawableId

    self halt:'Not yet implemented'

    "Created: / 10-09-2008 / 21:58:02 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!GLXWorkstation methodsFor:'drawing'!

displayArcX:x y:y width:width height:height from:startAngle angle:angle in:aDrawableId with:cr 
    ^ super 
        displayArcX:x
        y:y
        width:width
        height:height
        from:startAngle
        angle:angle
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

displayLineFromX:x0 y:y0 toX:x1 y:y1 in:aDrawableId with:cr 
    ^ super 
        displayLineFromX:x0
        y:y0
        toX:x1
        y:y1
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

displayLinesFromX:startX step:stepX yValues:yValues scaleY:scaleY transY:transY in:aDrawableId with:cr 
    ^ super 
        displayLinesFromX:startX
        step:stepX
        yValues:yValues
        scaleY:scaleY
        transY:transY
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

displayPointX:x y:y in:aDrawableId with:cr 
    ^ super 
        displayPointX:x
        y:y
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

displayPolygon:aPolygon in:aDrawableId with:cr 
    ^ super 
        displayPolygon:aPolygon
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

displayRectangleX:x y:y width:width height:height in:aDrawableId with:cr 
    ^ super 
        displayRectangleX:x
        y:y
        width:width
        height:height
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

displayString:aString from:index1 to:index2 x:x y:y in:aDrawableId with:cr opaque:opaque 
    ^ super 
        displayString:aString
        from:index1
        to:index2
        x:x
        y:y
        in:aDrawableId
        with:cr gcId
        opaque:opaque

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

displayString:aString x:x y:y in:aDrawableId with:cr opaque:opaque 
    ^ super 
        displayString:aString
        x:x
        y:y
        in:aDrawableId
        with:cr gcId
        opaque:opaque

    "Created: / 10-09-2008 / 21:10:48 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

drawBits:givenBits bitsPerPixel:bitsPerPixel depth:imageDepth padding:givenPadding
        width:imageWidth height:imageHeight
        x:srcx y:srcy
        into:aDrawableId
        x:dstx y:dsty
        width:w height:h
        with:cr

    ^super drawBits:givenBits bitsPerPixel:bitsPerPixel depth:imageDepth padding:givenPadding
                width:imageWidth height:imageHeight
                x:srcx y:srcy
                into:aDrawableId
                x:dstx y:dsty
                width:w height:h
                with:cr gcId

    "Created: / 10-09-2008 / 21:28:25 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

fillArcX:x y:y width:width height:height from:startAngle angle:angle
               in:aDrawableId with:cr

        ^super fillArcX:x y:y width:width height:height from:startAngle angle:angle
                       in:aDrawableId with:cr gcId

    "Created: / 10-09-2008 / 21:29:57 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

fillPolygon:aPolygon in:aDrawableId with:cr 
    ^ super 
        fillPolygon:aPolygon
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

fillRectangleX:x y:y width:width height:height in:aDrawableId with:cr 
    ^ super 
        fillRectangleX:x
        y:y
        width:width
        height:height
        in:aDrawableId
        with:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth msb:msb masks:maskArray padding:bitPadding
                             extent:imageExtent sourceOrigin:srcOrg
                               into:aDrawableId
                  destinationOrigin:dstOrg extent:dstExtent
                               with:cr

        ^super primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth msb:msb masks:maskArray padding:bitPadding
                             extent:imageExtent sourceOrigin:srcOrg
                               into:aDrawableId
                  destinationOrigin:dstOrg extent:dstExtent
                                       with:cr gcId

    "Created: / 10-09-2008 / 21:30:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth msb:msb padding:bitPadding

	^super primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth msb:msb padding:bitPadding

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth msb:msb padding:bitPadding
                              width:imageWidth height:imageHeight
                                  x:srcx y:srcy
                               into:aDrawableId
                                  x:dstx y:dsty
                              width:w height:h
                               with:cr
        ^super primDrawBits:imageBits bitsPerPixel:bitsPerPixel depth:imageDepth msb:msb padding:bitPadding
                              width:imageWidth height:imageHeight
                                  x:srcx y:srcy
                               into:aDrawableId
                                  x:dstx y:dsty
                              width:w height:h
                                       with:cr gcId

    "Created: / 10-09-2008 / 21:31:38 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!GLXWorkstation methodsFor:'graphic context stuff'!

noClipIn:aDrawableId gc:cr 
    ^ super noClipIn:aDrawableId gc:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setBackground:bgColorIndex in:cr 
    ^ super setBackground:bgColorIndex in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setBitmapMask:aBitmapId in:cr 
    ^ super setBitmapMask:aBitmapId in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setClipByChildren:aBool in:aDrawableId gc:cr 
    ^ super 
        setClipByChildren:aBool
        in:aDrawableId
        gc:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setClipX:clipX y:clipY width:clipWidth height:clipHeight in:drawableId gc:cr 
    ^ super 
        setClipX:clipX
        y:clipY
        width:clipWidth
        height:clipHeight
        in:drawableId
        gc:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setDashes:dashList dashOffset:offset in:cr 
    ^ super 
        setDashes:dashList
        dashOffset:offset
        in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setFont:aFontId in:cr 
    ^ super setFont:aFontId in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setForeground:fgColorIndex background:bgColorIndex in:cr 
    ^ super 
        setForeground:fgColorIndex
        background:bgColorIndex
        in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setForeground:fgColorIndex in:cr 
    ^ super setForeground:fgColorIndex in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setFunction:aFunctionSymbol in:cr 
    ^ super setFunction:aFunctionSymbol in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setGraphicsExposures:aBoolean in:cr 
    ^ super setGraphicsExposures:aBoolean in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setLineWidth:aNumber style:lineStyle cap:capStyle join:joinStyle in:cr 
    ^ super 
        setLineWidth:aNumber
        style:lineStyle
        cap:capStyle
        join:joinStyle
        in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

setPixmapMask:aPixmapId in:cr 
    ^ super setPixmapMask:aPixmapId in:cr gcId

    "Created: / 10-09-2008 / 21:10:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!GLXWorkstation methodsFor:'info messages'!

infoPrintCR:aString 
    Stdout
        nextPutAll:'Cairo [info] GLXWorkstation: ';
        nextPutAll: aString;
        cr

    "Created: / 10-09-2008 / 21:21:41 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!GLXWorkstation methodsFor:'window stuff'!

resizeWindow:aWindowId width:w height:h

    | view cr |
    super resizeWindow:aWindowId width:w height:h.
    view := self viewFromId: aWindowId.
    cr := view gcId.
    cr ifNil:[^self].
    self 
        assert: (cr isKindOf: GraphicsContext)
        message: 'GC of given view is not a Cairo context!!'.        
    view gcId surface width: w height: h

    "Created: / 10-09-2008 / 21:49:31 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!GLXWorkstation class methodsFor:'documentation'!

version
    ^'$Id$'
!

version_HG
    ^ '$Changeset: <not expanded> $'
! !
